// Copyright 2018 Dmitry Tantsur <divius.inside@gmail.com>
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

//! Image API implementation bits.

mod api;
mod images;
mod protocol;

pub use self::images::{Image, ImageQuery};
pub use self::protocol::{
    ImageContainerFormat, ImageDiskFormat, ImageSortKey, ImageStatus, ImageVisibility,
};
